<template lang='pug'>        
    v-list-tile(:key='"t-" + index', avatar, @click='', :class='{"with-answers": hasAnswers}')
        v-list-tile-avatar
            img(src='https://cdn.vuetifyjs.com/images/lists/5.jpg')
        v-list-tile-content(v-if='comment')
            v-list-tile-title {{comment.user}} ({{comment.id}})
            v-list-tile-sub-title(v-html='comment.text')                
            v-form.answer-form(v-if="formExpanded",ref="form", v-model="form", class="pa-3 pt-4")
                v-textarea(name='answer-input', label='Ответ:', v-model='answerOrQuestion', hint='bla bla')
                v-btn(small, flat, color="primary", @click='addAnswer') Отправить        
                v-btn(small, flat, @click='formExpanded = false') Отмена   
            v-flex
                v-btn(icon, @click='toggleForm', v-if='!formExpanded')
                    v-icon insert_comment
                v-btn(icon, @click='deleteComment', v-if='deletable')
                    v-icon delete           

            v-list.childrens(v-if="hasAnswers", three-line='')
                template(v-for="(sub, subkey) in comment.answers")        
                    comment-item(, :comment='sub', :index='subkey')

</template>


<script>
export default {
  name: "comment-item",
  props: ["comment", "index", "deletable"],
  data() {
    return {
      form: true,
      answerOrQuestion: "",
      formExpanded: false
    };
  },
  computed: {
    hasAnswers() {
      return this.comment && this.comment.answers;
    }
  },
  methods: {
    toggleForm() {
      this.formExpanded = !this.formExpanded;
    },
    addAnswer() {
      if (this.answerOrQuestion.length === 0) {
        alert("Поле пустое");
        return;
      }
      const obj = {
        id: 999,
        user: "Bill Gates",
        text: this.answerOrQuestion
      };
       
       this.$emit('answered', {index: this.index, data: obj});
     

      this.formExpanded = false;
      this.answerOrQuestion = "";
      alert("Готово!");
    },
    deleteComment() {
        this.$emit('deleted', {index: this.index});
    },
  }
};
</script>

<style lang="scss">
.answer-form {
  width: 100%;
}
</style>
